// $Id: Configuration.hh,v 1.18 1999/01/18 17:01:31 christof Exp $
/*  glade--: C++ frontend for glade (Gtk+ User Interface Builder)
 *  Copyright (C) 1998  Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <config.h>

struct Gtkmm_Version
{  int major;
   int minor;
   int micro;
   
   Gtkmm_Version() : major(0), minor(0), micro(0) {}
   Gtkmm_Version(int j,int n,int c) : major(j), minor(n), micro(c) {}
   bool operator==(const Gtkmm_Version &b) const 
   {  return major==b.major && minor==b.minor && micro==b.micro; }
   bool operator<(const Gtkmm_Version &b) const 
   {  if (major!=b.major) return major<b.major;
      if (minor!=b.minor) return minor<b.minor;
      return micro<b.micro;
   }
   bool operator>=(const Gtkmm_Version &b) const 
   {  return !(*this<b); }
   bool operator!=(const Gtkmm_Version &b) const 
   {  return !(*this==b); }
};

typedef Gtkmm_Version Gtk_Version;

struct Configuration
{  string destination_directory;
   string main_filename;
   string in_filename;
   string commandline;
   bool debug:1;
   bool sample_code:1;
   bool all_pointer:1;
   bool bare_bones:1;
   bool has_radiogroups:1;
   bool no_autoconf:1;
   bool gtk_ostream:1;
   int lookup_table;
   Gtk_Version gtk_version;
   Gtkmm_Version gtkmm_version;
   
   Configuration()
   : destination_directory(""), main_filename("main"), in_filename(""),
     debug(false), sample_code(false), all_pointer(false), 
     bare_bones(false), has_radiogroups(false),
     no_autoconf(false), gtk_ostream(false),
     lookup_table(0), 
     gtk_version(GTK_MAJOR,GTK_MINOR,GTK_MICRO),
     gtkmm_version(GTKMM_MAJOR,GTKMM_MINOR,GTKMM_MICRO)
   {}
};

extern struct Configuration Configuration;
