// $Id: arrow.cc,v 1.2 1998/09/24 13:19:43 cvs_christof Exp $
/*  glade--: C++ frontend for glade (Gtk+ User Interface Builder)
 *  Copyright (C) 1998  Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "writers.hh"

void Gtk_Arrow::Include(File &f,const Widget &w)
{  f.include("gtk--/arrow.h");
}

void Gtk_Arrow::Declare(File &f,const Widget &w)
{  StandardWriter::Declare(f,w,"Gtk_Arrow");
}

void Gtk_Arrow::Construct(File &f,const Widget &w,bool is_member)
{  f << StandardWriter::ConstructName(f,w,is_member,"Gtk_Arrow");
   string arrow_type(w.getString("arrow_type","GTK_ARROW_RIGHT"));
   string shadow_type(w.getString("shadow_type","GTK_SHADOW_OUT"));
   f << "(" << arrow_type << ", " << shadow_type << ")";
}

bool Gtk_Arrow::NeedConstruct(const Widget &w,bool is_member)
{  return true;
}

void Gtk_Arrow::Customize(File &f,const Widget &w,const string instance)
{  Gtk_Misc::Customize(f,w,instance);
}
