// $Id: checkmenuitem.cc,v 1.2 1998/10/30 17:03:19 cvs_christof Exp $
/*  glade--: C++ frontend for glade (Gtk+ User Interface Builder)
 *  Copyright (C) 1998  Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "writers.hh"

void Gtk_CheckMenuItem::Include(File &f,const Widget &w)
{  f.include("gtk--/checkmenuitem.h");
}

void Gtk_CheckMenuItem::Declare(File &f,const Widget &w)
{  StandardWriter::Declare(f,w,"Gtk_CheckMenuItem");
}

void Gtk_CheckMenuItem::Construct(File &f,const Widget &w,bool is_member)
{  f << StandardWriter::ConstructName(f,w,is_member,"Gtk_CheckMenuItem");
   f << "(\"" << f.CString(w.getString("label"))
	<< "\")";
}

bool Gtk_CheckMenuItem::NeedConstruct(const Widget &w,bool is_member)
{  return w.hasTag("label");
}

void Gtk_CheckMenuItem::Customize(File &f,const Widget &w,const string instance)
{  Gtk_MenuItem::Customize(f,w,instance);
   if (w.hasChildren())
   {  cerr << "CheckMenuItem with submenu, not recommended\n";
   }
   bool active=w.getBool("active");
   if (active) 
      f << instance << "set_state(" << (active?"true":"false") << ");\n\t";
   bool always_show_toggle=w.getBool("always_show_toggle");
   if (always_show_toggle) 
      f << instance << "set_show_toggle(" << (always_show_toggle?"true":"false") << ");\n\t";
}
