// $Id: list.cc,v 1.2 1998/12/01 12:57:21 christof Exp $
/*  glade--: C++ frontend for glade (Gtk+ User Interface Builder)
 *  Copyright (C) 1998  Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "writers.hh"

void Gtk_List::Include(File &f,const Widget &w)
{  f.include("gtk--/list.h");
}

void Gtk_List::Declare(File &f,const Widget &w)
{  StandardWriter::Declare(f,w,"Gtk_List");
}

void Gtk_List::Derive(File &f,const Widget &w)
{  f << "Gtk_List";
}

void Gtk_List::Construct(File &f,const Widget &w,bool is_member)
{  f << StandardWriter::ConstructName(f,w,is_member,"Gtk_List") << "()";
}

bool Gtk_List::NeedConstruct(const Widget &w,bool is_member)
{  return false;
}

void Gtk_List::Customize(File &f,const Widget &w,const string instance)
{  Gtk_Container::Customize(f,w,instance);
   string selection_mode=w.getString("selection_mode","GTK_SELECTION_SINGLE");
   if (selection_mode!="GTK_SELECTION_SINGLE")
      f << instance << "set_selection_mode(" << selection_mode << ");\n\t";
}
