// $Id: tclist.cc,v 1.1 1998/12/18 09:23:27 christof Exp $
/*  glade--: C++ frontend for glade (Gtk+ User Interface Builder)
 *  Copyright (C) 1998  Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "writers.hh"

void TCList::Include(File &f,const Widget &w)
{  f.include("TCList.h");
   Gtk_Container::Include(f,w);
}

void TCList::Declare(File &f,const Widget &w)
{  StandardWriter::Declare(f,w,"TCList");
}

void TCList::Derive(File &f,const Widget &w)
{  f << "TCList";
}

void TCList::Construct(File &f,const Widget &w,bool is_member)
{  // 2do: look for columns and pass them
   int columns=w.getInt("columns",3);
   f << StandardWriter::ConstructName(f,w,is_member,"TCList");
   f << "("<< columns << ")";
}

bool TCList::NeedConstruct(const Widget &w,bool is_member)
{  return true; // doesn't have default constructor
}

void TCList::Customize(File &f,const Widget &w,const string instance)
{  Gtk_CList::Customize(f,w,instance);
}

WriterType::Subwidget TCList::IsSubwidget(const Widget &w,const Widget &ch)
{  return WriterType::IgnoreTree; // only on labels !
}

bool TCList::SampleCode(File &f,const Widget &w,enum WriterType::CodePosition pos,const string misc)
{  
#warning 2do: sample code
   return false;
}

const string TCList::CallbackArgs(const Widget &w,const string signal,string &rettype)
{  return Gtk_CList::CallbackArgs(w,signal,rettype);
}
